#ifdef _VERTEX_

void main()
{
    gl_Position = ftransform();
    gl_TexCoord[0] = gl_MultiTexCoord0;
}

#else

float   HeightMapTerra(vec3 point)
{
    // Global landscape
    vec3  p = point * mainFreq + Randomize;
    noiseOctaves = 5;
    vec3  distort = 0.35 * FbmVec3(p * 2.37);
    noiseOctaves = 4;
    distort += 0.005 * (1.0 - abs(FbmVec3(p * 132.3)));
    float global = 1.0 - Cell3Noise(p + distort) +  ( 0.05 * hillsMagn * (1.5 - RidgedMultifractal(point * hillsFreq + Randomize, 2.0)));

    // Venus-like structure
    float venus = 0.0;
    if (venusMagn > 0.05)
    {
        noiseOctaves = 4;
        distort = FbmVec3(point * 0.3) * 1.5;
        noiseOctaves = 6;
        venus = Fbm((point + distort) * venusFreq) * venusMagn;
    }

    global += venus;
    global = (global - seaLevel) * 0.5 + seaLevel;
    




/**/

    vec4  col;
    noiseOctaves = 6;
    p = p * 2.3 + 3.5 * FbmVec3(p * 0.6);
    vec2  cell = Cell3Noise2Color(p, col);
    float biome = col.r;
    float biomeScale = saturate(2.0 * (pow(abs(cell.y - cell.x), 0.7) - 0.05));
    float terrace = col.g;
    float terraceLayers = max(col.b * 10.0 + 3.0, 3.0);
    terraceLayers += Fbm(p * 5.41);

    float height = 0.0;
    float dist;


noiseOctaves = 3.2;
distort = 0.25 * FbmVec3(p * 10.8);
    float pseudoRivers = 0.5 * abs(0.9 - Cell3Noise(3.1 * p + (0.5 *  distort))) * 0.05 * (5.5 - RidgedMultifractalErodedDetail(point * 0.15 * hillsFreq/(hillsMagn*hillsMagn) + Randomize, 2.0, erosion, biomeScale));
pseudoRivers = 1.0 - smoothstep(0.0, 1.0, pseudoRivers * 200.0);
global -= pseudoRivers * RidgedMultifractal(Randomize, 0.05);

    //float shore = (global - seaLevel + 0.05) / 0.05;
    //shore = saturate(exp(-shore*shore));
    float shore = saturate(70 * (global - seaLevel));
    if (biome < dunesFraction)
    {
        // Dunes
        noiseOctaves = 5.0;
        dist = dunesFreq + Fbm(p * 1.21);
        height = biomeScale * dunesMagn * max(Fbm(p * dist * 0.3) + 0.7, 0.0);
        //height = Fbm(p * dist * 0.3);
        //height = 1.0 - abs(height);
        //height *= biomeScale * dunesMagn;
    }
    else if (biome < hillsFraction)
    {
        // "Eroded" hills
        noiseOctaves = 10.0;
        noiseH       = 1.0;
        noiseOffset  = 1.0;
        height = shore * biomeScale * hillsMagn * (1.5 - RidgedMultifractal(point * hillsFreq + Randomize, 2.0));
    }
    else if (biome < hills2Fraction)
    {
        // "Eroded" hills 2
        noiseOctaves = 10.0;
        noiseLacunarity = 2.0;
        height = shore * biomeScale * hillsMagn * JordanTurbulence(point * hillsFreq + Randomize, 0.8, 0.5, 0.6, 0.35, 1.0, 0.8, 1.0);
    }
    else if (biome < canyonsFraction)
    {
        // Canyons
       float rage = saturate(DistNoise(point * 42.6 + Randomize, 2.5) + 0.5);
        //biomeScale = min(pow(1.2 * biomeScale, 2.5), 1.0) * rage;
        //noiseOctaves = 10.0;
        //noiseH       = 1.0;
        //noiseOffset  = montesSpiky;
        biomeScale = min(pow(2.2 * biomeScale, 2.5), 1.0) * rage;
        noiseOctaves = 5.0;
        noiseH       = 0.65;
        noiseLacunarity = 4.0;
        noiseOffset  = montesSpiky;
        if (erosion > 0)
            height = RidgedMultifractalErodedDetail(point * 5 * canyonsFreq/(montesSpiky*montesSpiky) + Randomize, 1.0, erosion, biomeScale);
        else
            height = RidgedMultifractalDetail(point * 5 * canyonsFreq/(montesSpiky*montesSpiky) + Randomize, 1.0, biomeScale);
        height *= - canyonsMagn * rage * rage * rage;
        //height = max(height, -0.2);



        //if (terrace < terraceProb)
        {
            terraceLayers *= 5.0;
            float h = height * terraceLayers;
            height = (floor(h) + smoothstep(0.1, 0.9, fract(h))) / terraceLayers;
        }
    }
    else
    {
        // Mountains
        float rage = saturate(DistNoise(point * 42.6 + Randomize, 2.5) + 0.5);
        //biomeScale = pow(1.2 * biomeScale, 5.0);
        biomeScale = min(pow(1.2 * biomeScale, 2.5), 1.0) * rage;
        noiseOctaves = 10.0;
        noiseH       = 1.0;
        noiseOffset  = montesSpiky;
        if (erosion > 0)
            height = RidgedMultifractalErodedDetail(point * montesFreq/(montesSpiky*montesSpiky) + Randomize, 2.0, erosion, biomeScale);
        else
            height = 0.75 * RidgedMultifractalDetail(point * montesFreq/(montesSpiky*montesSpiky) + Randomize, 2.0, biomeScale);
        height *= montesMagn * rage;
        if (terrace < terraceProb)
        {
            float h = height * 0.75 * terraceLayers;
            height = (floor(h) +  smoothstep(0.1, 0.9,  fract(h))) / terraceLayers;
        }
        //height *= shore;
    }

    // Mare
    float mare = global;
    if (mareSqrtDensity > 0.05)
    {
        noiseH          = 0.5;
        noiseLacunarity = 2.218281828459;
        noiseOffset     = 0.8;
        craterDistortion = 1.0;
        noiseOctaves = 6;  // Mare roundness distortion
        mare = MareNoise(point, global, 0.0);
    }

    // Ice cracks
    if (cracksOctaves > 0.0)
    {
        // Rim height distortion
        noiseH          = 0.5;
        noiseLacunarity = 2.218281828459;
        noiseOffset     = 0.8;
        noiseOctaves    = 4.0;
        float dunes = 2 * cracksMagn * (0.2 + dunesMagn * max(Fbm(point * dunesFreq) + 0.7, 0.0));
        noiseOctaves    = 6.0;
        height += CrackNoise(point, dunes);
    }

    // Craters
    float crater = 0.0;
    if (craterSqrtDensity > 0.05)
    {
        noiseOctaves = 3;  // Craters roundness distortion
        craterDistortion = 1.0;
        craterRoundDist  = 0.03;
        heightFloor = -0.1;
        heightPeak  = 0.6;
        heightRim   = 1.0;
        crater = CraterNoise(point, 0.5 * craterMagn, craterFreq, craterSqrtDensity, craterOctaves);
        noiseOctaves = 10.0;
        noiseH       = 1.0;
        noiseOffset  = 1.0;
        if (erosion > 0)
            crater = RidgedMultifractalErodedDetail(point * 0.3 * montesFreq + Randomize, 2.0, erosion, 0.25 * crater);
        else
            crater = RidgedMultifractalDetail(point * 0.3 * montesFreq + Randomize, 2.0, 0.25 * crater);
    }

    height += mare + crater;

    // Assign a climate type
    noiseOctaves = (cloudsStyle == 1.0) ? 5.0 : 12.0;
    noiseH          = 0.5;
    noiseLacunarity = 2.218281828459;
    noiseOffset     = 0.8;
    float latitude;
    if (tidalLock == 0.0)
    {
        latitude = abs(point.y);
        latitude += 0.15 * (Fbm(point * 0.7 + Randomize) - 1.0);
        latitude = saturate(latitude);
    }
    else
    {
        latitude = 1.0 - point.x;
        latitude += 0.15 * (Fbm(point * 0.7 + Randomize) - 1.0);
    }

    // Ice caps
    float edge;
    if (cloudsStyle == 1.0)
    {
        edge = saturate(15.0 * (latitude - latIceCaps));
        height = height * 0.1 + icecapHeight * edge;
    }
    else
    {
        edge = saturate(3.0 * (latitude - latIceCaps));
        height += icecapHeight * sqrt(edge);
    }

    return height;
}

void main()
{
    vec3  point = GetSurfacePoint();
    float height = HeightMapTerra(point);
    gl_FragColor = vec4(height);
}

#endif
